#!/bin/bash

# load config
WORK_DIR="/var/mikbill/policer"
RATE_LIMIT_DIR="/proc/net/ipt_ratelimit"
source $WORK_DIR/config.cfg

# default interval
INTERVAL="1"

# get current interval
if [ -f $WORK_DIR/current.itrvl ]; then
	INTERVAL=$(cat $WORK_DIR/current.itrvl)
fi

# hard limit
if [ "$INTERVAL" -eq "0" ]; then
	SPEED_IN=$HARD_LIMIT_RX
	SPEED_OUT=$HARD_LIMIT_TX
fi

# parse info from radius on day
if [ "$INTERVAL" -eq "1" ]; then
	SPEED_IN=$(cat /tmp/radattr.$1 | awk -F, '/Filter-Id 1,/ {print $2}' | awk -F/ '{print $1}')
	if [ -z "$SPEED_IN" ]; then
		SPEED_IN=$(cat /tmp/radattr.$1 | awk '/Filter-Id / {print $2}' | awk -F/ '{print $1}')
	fi
	SPEED_OUT=$(cat /tmp/radattr.$1 | awk -F, '/Filter-Id 1,/ {print $2}' | awk -F/ '{print $2}')
	if [ -z "$SPEED_OUT" ]; then
		SPEED_OUT=$(cat /tmp/radattr.$1 | awk '/Filter-Id / {print $2}' | awk -F/ '{print $1}')
	fi
fi

# parse info from radius on night
if [ "$INTERVAL" -eq "2" ]; then
        SPEED_IN=$(cat /tmp/radattr.$1 | awk -F, '/Filter-Id 2,/ {print $2}' | awk -F/ '{print $1}')
	if [ -z "$SPEED_IN" ]; then
		SPEED_IN=$(cat /tmp/radattr.$1 | awk '/Filter-Id / {print $2}' | awk -F/ '{print $1}')
	fi
        SPEED_OUT=$(cat /tmp/radattr.$1 | awk -F, '/Filter-Id 2,/ {print $2}' | awk -F/ '{print $2}')
	if [ -z "$SPEED_OUT" ]; then
		SPEED_OUT=$(cat /tmp/radattr.$1 | awk '/Filter-Id / {print $2}' | awk -F/ '{print $1}')
	fi
fi

# set client ip address
IP=$5
# transform Kb => Mb
SPEED_IN=$(($SPEED_IN * 1000))
SPEED_OUT=$(($SPEED_OUT * 1000))

# log
echo "`date` [$INTERVAL] $5 limits: $SPEED_IN / $SPEED_OUT" > /tmp/$1_shaper.log

if [ "$SPEED_IN" -ne "0" ] && [ ! -z "$SPEED_IN" ]
then
	# log and set download speed rate
	echo "echo @+$IP $SPEED_IN" >> /tmp/$1_shaper.log
	echo @+$IP $SPEED_IN > $RATE_LIMIT_DIR/$RX_LIST
fi

if [ "$SPEED_OUT" -ne "0" ] && [ ! -z "$SPEED_OUT" ]
then
	# log and set upload speed rate
	echo "echo @+$IP $SPEED_OUT" >> /tmp/$1_shaper.log
	echo @+$IP $SPEED_OUT > $RATE_LIMIT_DIR/$TX_LIST
fi
